<template>
  <div
    v-if="mediaScreen > 639 && !isReferralHistory"
    v-loading="isLoading"
    class="max-h-full min-h-full pt-6 px-9 --text4"
  >
    <div class="flex justify-center items-center referral-page-desktop h-full">
      <div class="flex flex-col gap-4 refer-your-friend">
        <div class="flex flex-col gap-4">
          <p class="text-[var(--secondary)] font-bold text-[24px] w-[230px] text-center leading-[28.13px]">
            {{ $t("refer_your_friend_to_get_more_reward") }}
          </p>
          <img
            :src="getAssetImage('assets/referral/pic-referral.png')"
            class="w-[240px]"
          />
        </div>
        <div class="flex flex-col gap-4">
          <qrcode-vue
            id="qrCode"
            :value="referralLink"
            :size="200"
            class="p-2 bg-white rounded"
          ></qrcode-vue>
          <button
            type="button"
            class="flex gap-1 justify-center rounded-[20px] bg-[var(--primary)] py-[10px] w-[200px]"
            @click="onCopyQRCode"
          >
            <SvgIcon svg-name="icon-download" class="icon w-5 h-5" />
            <span class="font-bold">{{ $t("download") }}</span>
          </button>
          <button
            type="button"
            class="flex gap-1 justify-center rounded-[20px] bg-[var(--primary)] py-[10px] w-[200px]"
            @click="onCopyTextToClipBoard"
          >
            <SvgIcon svg-name="icon-copy" class="icon w-5 h-5" />
            <span class="font-bold">{{ $t("copy_link") }}</span>
          </button>
        </div>
      </div>
    </div>
  </div>
  <div v-else>
    <div
      class="w-full min-h-[93px] text-center py-5"
      style="border-bottom: 2px solid var(--border)"
    >
      <h1 class="text-[var(--primary)] text-[28px] leading-[32.81px]">{{ referralForDisplay }}</h1>
      <div class="text-[var(--text)] font-normal">
        {{ $t("you've_been_reward") }}
        <SvgIcon
          svg-name="icon-info"
          class="w-3 h-3 inline"
          style="fill: #d3dec4"
        />
      </div>
    </div>
    <div
      class="w-full py-4 px-6 text-center mobile-divider"
    >
      <div class="flex justify-between items-center mx-auto max-w-[315px]">
        <div class="flex flex-col items-end justify-end">
          <p class="text-[var(--text)] font-normal text-xs leading-[14px] mb-1">{{ $t('redeemable') }}</p>
          <h3 class="text-[var(--primary)] text-[16px] leading-[19px]">{{ redeemableForDisplay }}</h3>
        </div>
        <div>
          <SvgIcon
            svg-name="icon-arrow-next"
            class="w-5 h-5"
            style="fill: #03b001"
          />
        </div>
        <div class="flex flex-col justify-center items-start">
          <p class="text-[var(--text)] font-normal text-xs leading-[14px] mb-1">{{ $t('redeemed') }}</p>
          <h3 class="text-[var(--secondary)] text-[16px] leading-[19px]">
            {{ redeemedForDisplay }}
          </h3>
        </div>
      </div>
      <button type="button" class="btn-redeem-now text-[14px] leading-[16px]" @click="onRedeemNow">
        Redeem Now
      </button>
      <el-dialog
        v-model="dialogVisible"
        custom-class="cus-redeemed-dialog"
        destroy-on-close
      >
        <template #title>Redeem</template>
        <div class="dialog-refer-friend">
          <referral-modal v-if="!isLoading" position-label="top" />
        </div>
      </el-dialog>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, watch } from "vue";
import QrcodeVue from "qrcode.vue";
import _ from "lodash";

export default defineComponent({
  components: {
    QrcodeVue,
  },
  setup() {
    const {
      referralForDisplay,
      isLoading,
      onRedeemNow,
      rebet,
      referralCount,
      totalForDisplay,
      totalRewardForDisplay,
      redeemedForDisplay,
      redeemableForDisplay,
      dialogVisible,
    } = useReferralComponent();
    watch(
      () => dialogVisible.value,
      () => {
        const contentContainer: HTMLElement | null = document.querySelector(
          'div[layout="black_modern_desktop_1"] #content-container'
        );
        if (!contentContainer) return;

        if (dialogVisible.value) {
          contentContainer.style.zIndex = "30";
          return;
        }
        contentContainer.style.zIndex = "0";
      }
    );
    const mediaScreen = window.innerWidth;
    const { getAssetImage } = commonHelper;
    const route = useRoute();
    const {
      referralLink,
      onCopyTextToClipBoard,
      onCopyQRCode,
    } = useReferral();
    const isReferralHistory = computed(() =>
      route.path.includes('/history')
    );
    return {
      referralForDisplay,
      isLoading,
      onRedeemNow,
      totalForDisplay,
      referralCount,
      redeemedForDisplay,
      rebet,
      totalRewardForDisplay,
      redeemableForDisplay,
      dialogVisible,
      mediaScreen,
      getAssetImage,
      referralLink,
      onCopyTextToClipBoard,
      onCopyQRCode,
      isReferralHistory,
    };
  },
});
</script>
<style lang="postcss" scoped>
@media screen and (max-width: 880px) {
  .box-show-data-content {
    min-width: unset;
    display: flex;
    flex-direction: column;
    margin-left: auto;
    margin-right: auto;
    width: 100%;
  }
  .box-show-data {
    border-right: 0px !important;
    @apply border-b-2 border-r-0;
  }
  .box-show-data:last-child {
    @apply border-b-0;
  }
}

.box-show-data {
  @apply border-r-2 flex flex-col items-center my-4 py-3 px-8;
}
.box-show-data:last-child {
  @apply border-r-0;
}
:deep(.el-dialog__title) {
  font-weight: bold;
  font-size: 20px;
  color: var(--text);
}
.btn-redeem-now {
  border-radius: 20px;
  border: 1px solid var(--primary);
  width: 152px;
  height: 40px;
  background: transparent;
  color: var(--primary);
  margin-top: 1rem;
  font-weight: 400;
}
</style>
<style lang="scss">
.cus-redeemed-dialog {
  min-height: 256px;
  background: var(--background5);
  border-radius: 8px;
  width: calc(100% - 2rem);
  border: 2px solid var(--border);

  .el-dialog__headerbtn {
    top: 2px;
  }
  .el-icon.el-dialog__close {
    height: 18px;
    width: 18px;
    color: black;
    border-radius: 50%;
    background: var(--primary);
  }

  .el-dialog__header {
    margin-right: 0;
    border-bottom: 2px solid var(--border);
    padding: 1rem;
    text-align: left;
  }

  .fc-text {
    color: var(--secondary) !important;
    font-weight: 700 !important;
    margin-bottom: 8px;
  }
  .el-input__inner {
    height: 40px;
    color: var(--primary);
  }
  .mt-3.flex.justify-end {
    justify-content: center;
    button {
      height: 40px;
      width: 152px;
      font-size: 16px;
    }
  }
}
@media only screen and (min-width: 768px) {
  [layout='peru'] {
    .referral-referral {
      height: 100%;
      .el-scrollbar__wrap {
        display: flex;
        justify-content: center;
        align-items: center;
        height: 92%;
      }
      .referral-page-desktop {
        height: 100%;
        .refer-your-friend {
          flex-direction: row;
        }
      }
    }
  }
  .cus-redeemed-dialog {
    width: 500px;
  }
  .mobile-divider {
    margin-bottom: 0 !important;
    border: 0;
  }
}
.mobile-divider {
  @apply mb-4 border-b-2 border-[var(--border)];
}
[layout='peru'].referral {
  .el-scrollbar {
    .el-scrollbar__view {
      width: 100%;
    }
    margin: unset;
  }
}
</style>
